<?php

namespace FiloBlu\Refilo\Model\Indexer\Core;

use FiloBlu\Refilo\Model\Adapter\Mongo;
use FiloBlu\Refilo\Model\Indexer\Core\Provider\QueryProviderInterfaceFactory;

class BaseMongoIndexer extends AbstractMongoIndexer
{
    /**
     * @var string
     */
    private $mongoKey;
    /**
     * @var string
     */
    private $mongoCollection;
    /**
     * @var bool
     */
    private $insertMode;

    /**
     * BaseMongoIndexer constructor.
     * @param SqlToMongoAdapterInterface $sqlToMongoAdapter
     * @param QueryProviderInterfaceFactory $queryProviderFactory
     * @param Mongo $mongo
     * @param string $mongoKey
     * @param string $mongoCollection
     * @param bool $insertMode
     */
    public function __construct(
        SqlToMongoAdapterInterface $sqlToMongoAdapter,
        QueryProviderInterfaceFactory $queryProviderFactory,
        Mongo $mongo,
        string $mongoKey,
        string $mongoCollection,
        bool $insertMode
    ) {
        parent::__construct($sqlToMongoAdapter, $queryProviderFactory, $mongo);
        $this->mongoKey = $mongoKey;
        $this->mongoCollection = $mongoCollection;
        $this->insertMode = $insertMode;
    }

    public function getMongoKey(): string
    {
        return $this->mongoKey;
    }

    public function getTargetMongoCollection(): string
    {
        return $this->mongoCollection;
    }

    public function setInsertMode(): bool
    {
        return $this->insertMode;
    }
}
